/* The game of Roll by Bjarne, November 1996. */

import java.awt.*;
import java.util.*;

public class Roll extends Frame
{
  //////// The Application interface

  public Roll()
  {
    setTitle("Roll");
    canvas = new Canvas();
    canvas.setBackground(Color.yellow);
    Panel p = new Panel();
    p.add(s1 = new Label("You win 0", Label.LEFT));
    p.add(s2 = new Label("You loose 0", Label.RIGHT));
    p.add(Bstop = new Button("Stop"));
    add("Center", canvas);
    add("South", p);
  }

  public static void main(String[] args)
  {
    int magicx = 10, magicy = 60;

    Frame f = new Roll();
    f.resize(600 + magicx, 600 + magicy);
    f.setResizable(false);
    f.show();
  }

  /////// Public methods called by the system

  public boolean handleEvent(Event evt)
  {
    if (evt.id == Event.MOUSE_MOVE)
      b.tilt(evt.x,evt.y);
    else if (evt.id == Event.WINDOW_DESTROY)
      System.exit(0);
    else create();
    return super.handleEvent(evt);
  }

  public boolean action(Event evt, Object arg)
  {
    if (evt.target == Bstop && arg.equals("Stop"))
      System.exit(0);           // Meaningless in the Applet

    return super.action(evt, arg);
  }

  public void paint(Graphics g)
  {
    System.out.println("Now Roll should paint"); // How to do this ????
  }

  public void update(Graphics g)
  {
    System.out.println("Now Roll should update"); // How to do this ????
  }

  public void stop()
  {
    System.out.println("Now Roll should stop"); // How to do this ????
  }

  public void start()
  {
    System.out.println("Now Roll should start"); // How to do this ????
  }

  //////// Private methods

  private void create()
  {
    if (first)
      {
        int border = 2;
        d = canvas.size();
        g = canvas.getGraphics();
        (danger[0] = new Square(canvas, Color.black,
                                0, 0, 100, 100, bsize)).start();
        (danger[1] = new Square(canvas, Color.black,
                                500, 250, 100, 100, bsize)).start();
        (danger[2] = new Square(canvas, Color.black,
                                300, 500, 100, 100, bsize)).start();
        (bounce[0] = new Square(canvas, Color.blue,
                                250, 100, 300, 50, bsize)).start();
        (bounce[1] = new Square(canvas, Color.blue,
                                100, 100, 50, 200, bsize)).start();
        (bounce[2] = new Square(canvas, Color.blue,
                                250, 300, 100, 100, bsize)).start();
        (bounce[3] = new Square(canvas, Color.blue,
                                0, 450, 200, 50, bsize)).start();
        (b = new Ball(canvas, Color.red, border, danger, bounce,
                      bsize, s1, s2)).start();
        (w1 = new Word(canvas, "Start", 550, 25)).start();
        (w2 = new Word(canvas, "Finish", 10, 580)).start();
        g.drawLine(dist, border, d.width-dist, border);
        g.drawLine(dist, d.height-border, d.width-dist, d.height-border);
        first = false;
      }
  }

  private void restart()
  {
    b.restart();
  }

  private int dist = 300;
  private boolean first = true;
  private Ball b = null;
  private Word w1 = null, w2 = null;
  private int bsize = 40;        // ball size
  private Square [] danger = new Square [3];
  private Square [] bounce = new Square [4];
  private Button Bstop;
  private Label s1, s2;
  private Canvas canvas;
  private Dimension d;
  private Graphics g;
}

class Word extends Thread
{
  /////// Public methods called by the system

  public Word(Canvas ca, String word, int i1, int i2)
  {
    canvas = ca;
    x = i1;
    y = i2;
    text = word;
    g = canvas.getGraphics();
    g.setXORMode(ca.getBackground());
    g.setColor(Color.black);
  }

  public void run()
  {
    xor_draw();
  }

  //////// Private methods

  private void xor_draw()
  {
    if (canvas.isValid()) g.drawString(text, x, y);
  }

  private int x, y;
  private String text;
  private Canvas canvas;
  private Graphics g;
}

class Square extends Thread
{
  /////// Public methods called by the system

  public Square(Canvas ca, Color co, int i1, int i2, int i3, int i4, int bsize)
  {
    canvas = ca;
    color = co;
    x = i1;
    y = i2;
    w = i3;
    h = i4;
    x1 = x + w;
    y1 = y + h;
    a = x - bsize;
    b = y - bsize;
    c = x1;
    d = y1;
    g = canvas.getGraphics();
    g.setXORMode(ca.getBackground());
    g.setColor(co);
  }

  public void run()
  {
    xor_draw();
  }

  public boolean fall_into(int xb, int yb)
  {
    if (x < xb && xb < x1 && y < yb && yb < y1)
      return(true);
    else
      return(false);
  }

  public boolean bounce_left(int xb, int yb, int xn, int yn, int [] answ)
  {
    if (xb <= a && a < xn)
      {
        int bn = ((a - xb) * (yn - yb)) / (xn - xb) + yb;
        if (b <= bn && bn <= d)
          { answ[0] = a; answ[1] = bn; return(true); }
        else return(false);
      }
    else return(false);
  }

  public boolean bounce_right(int xb, int yb, int xn, int yn, int [] answ)
  {
    if (xb >= c && c > xn)
      {
        int bn = ((c - xb) * (yn - yb)) / (xn - xb) + yb;
        if (b <= bn && bn <= d)
          { answ[0] = c; answ[1] = bn; return(true); }
        else return(false);
      }
    else return(false);
  }

  public boolean bounce_above(int xb, int yb, int xn, int yn, int [] answ)
  {
    if (yb <= b && b < yn)
      {
        int an = ((b - yb) * (xn - xb)) / (yn - yb) + xb;
        if (a <= an && an <= c)
          { answ[0] = an; answ[1] = b; return(true); }
        else return(false);
      }
    else return(false);
  }

  public boolean bounce_below(int xb, int yb, int xn, int yn, int [] answ)
  {
    if (yb >= d && d > yn)
      {
        int an = ((d - yb) * (xn - xb)) / (yn - yb) + xb;
        if (a <= an && an <= c)
          { answ[0] = an; answ[1] = d; return (true); }
        else return(false);
      }
    else return(false);
  }

  //////// Private methods

  private void xor_draw()
  {
    if (canvas.isValid()) g.fillRect(x, y, w, h);
  }

  private int x, y, w, h, x1, y1, a, b, c, d;
  private Canvas canvas;
  private Color color;
  private Graphics g;
}

class Ball extends Thread
{
  /////// Public methods called by the system

  public Ball(Canvas c, Color co, int bo,
              Square [] da, Square [] bu, int bs, Label lab1, Label lab2)
  {
    d = c.size();
    canvas = c;
    color = co;
    border = bo;
    bsize = bs;
    halfbsize = bs / 2;
    s1 = lab1;
    s2 = lab2;
    xmax = d.width - bsize;
    ymax = d.height - bsize;
    xstart = xmax - bsize - 10;
    ystart = bsize + 10;
    middlex = d.width / 2;
    middley = d.height / 2;
    xwin = bsize / 2;
    ywin = ymax - bsize / 2;
    danger = da;
    bounce = bu;
    g = canvas.getGraphics();
    g.setXORMode(canvas.getBackground());
    g.setColor(color);
  }

  public void run()
  {
    while (true)
      {
        reinit();
        xor_draw();
        try { sleep(1000); }
        catch(InterruptedException e) {}

        while (true)
          {
            move();
            try { sleep(25); }
            catch(InterruptedException e) {}
            if (do_restart) break;
          }
        xor_draw();
      }
  }

  /////// My own public methods

  public void restart() { do_restart = true; }

  public void tilt(int tx,int ty)
  {
    tiltx = tx - middlex;
    tilty = ty - middley;
  }

  //////// Private methods

  private void reinit()
  {
    startpos();
    do_restart = false;
  }

  private void startpos()
  {
    x = xstart;
    y = ystart;
    tiltx = 0;
    tilty = 0;
    dx = 0.0;
    dy = 0.0;
  }

  private void xor_draw()
  {
    if (canvas.isValid()) g.fillOval(x, y, bsize, bsize);
  }

  private void move()
  {
    int xn, yn;

    xor_draw();
    dx = newdelta(tiltx, dx);
    dy = newdelta(tilty, dy);
    xn = x + (int) (dx + 0.5);
    yn = y + (int) (dy + 0.5);

    for (i = 0; i < danger.length; i++)
      {
        if (danger[i].fall_into(xn + halfbsize, yn + halfbsize))
          {
            you_loose = you_loose + 1;
            s2.setText("You loose " + you_loose);
            startpos();
            xor_draw();
            return;
          }
      }

    if (xn < xwin && yn > ywin)
      {
        you_win = you_win + 1;
        s1.setText("You win " + you_win);
        startpos();
        xor_draw();
        return;
      }

    if (xn > x)
      {
        if (xn > xmax)
          {xn = xmax; dx = -dx; }
        else for (i = 0; i < bounce.length; i++)
          {
            if (bounce[i].bounce_left(x, y, xn, yn, answ))
              {xn = answ[0]; yn = answ[1]; dx = -dx; break; }
          }
      }
    else if (xn < x)
      {
        if (xn < 0)
          {xn = 0; dx = -dx; }
        else for (i = 0; i < bounce.length; i++)
          {
            if (bounce[i].bounce_right(x, y, xn, yn, answ))
              {xn = answ[0]; yn = answ[1]; dx = -dx; break; }
          }
      }
    if (yn > y)
      {
        if (yn > ymax)
          {yn = ymax; dy = -dy; }
        else for (i = 0; i < bounce.length; i++)
          {
            if (bounce[i].bounce_above(x, y, xn, yn, answ))
              {xn = answ[0]; yn = answ[1]; dy = -dy; break; }
          }
      }
    else if (yn < y)
      {
        if (yn < 0)
          {yn = 0; dy = -dy; }
        else for (i = 0; i < bounce.length; i++)
          {
            if (bounce[i].bounce_below(x, y, xn, yn, answ))
              {xn = answ[0]; yn = answ[1]; dy = -dy; break; }
          }
      }
    x = xn;
    y = yn;
    xor_draw();
  }

  private double newdelta(int tilt, double delta)
  {
    double ftilt, deltan;

    ftilt = (double) tilt;

    if (ftilt > 0.0 && delta < 0.0)
      deltan = delta + ftilt / 500.0;
    else if (ftilt < 0.0 && delta > 0.0)
      deltan = delta + ftilt / 500.0;
    else if (delta > d.height)
      deltan = d.height;
    else if (delta < - d.height)
      deltan = - d.height;
    else
      deltan = delta + ftilt / 2000.0;

    return(deltan);
  }

  private int x, y, tiltx, tilty, xmax, ymax, bsize, halfbsize;
  private int i, xstart, ystart, middlex, middley, xwin, ywin;
  private int [] answ = new int [2];
  private int you_win = 0, you_loose = 0;
  private double dx = 0.0, dy = 0.0;
  private Square [] danger, bounce;
  private Label s1, s2;
  private int border;
  private boolean do_restart;
  private Canvas canvas;
  private Graphics g;
  private Color color;
  private Dimension d;

}
