module BitmapOps(doubleBM,bm,BitmapData(..)) where
import AllFudgets(BitmapData(..),Point(..),Size)
import Data.List.Split(chunksOf)

data E = E Size [[Bit]] deriving Eq
type Bit = Bool

doubleBM = implodeE . doubleE . explodeBM

doubleE (E s rows) = E (s+s) (double (map double rows))

double = foldr (\x r->x:x:r) []

{-
instance Show E where
  show (E _ rows) = unlines [[".*"!!fromEnum b|b<-row]|row<-rows]
  showList = (++) . unlines . map show
-}

explodeBM (BitmapData s@(Point w h) _ bytes) = E s rows
  where
    b = (w+7) `div` 8
    rows = map (take w . concatMap explode) (chunksOf b bytes)

implodeE (E s@(Point w h) rows) = BitmapData s Nothing bytes
   where
     bytes = concatMap (map implode . chunksOf 8) rows

implode = foldr (\b r->fromEnum (b::Bit)+2*r) 0

explode = take 8.expl
  where
    expl n = (n `mod` 2 /= 0):expl (n `div` 2)

bm w h = BitmapData (Point w h) Nothing
