module GUI(Draw(..),HasSize(..),PlacedPict(..),clear,clearpm,clearRect,wDraw,
           Pict,GCId,objGC,readPicts,readPict,rectangles,text,
           GEvent(..),Action(..),UpDown(..),
           G,putGUI,putsGUI,putLives,putScore,getG,nullG,spaceF,
           baseColor, shotColor, shelterColor, ufoColor,
           vader1Color, vader2Color, vader3Color, vshotColor
           ) where
import Control.Applicative
import AllFudgets hiding (draw,wDraw,size,state,rect)
import ReadPic
{-
type G i o = K i o

nullG = nullK
putLives l = putK (High (Left l))
putScore s = putK (High (Right s))
putGUI gfx = putK (Low gfx)
putsGUI gfx = putsK (map Low gfx)
-}
type G i o = KSP i o

nullG = nullSP
putLives l = putSP (High (Left l))
putScore s = putSP (High (Right s))
putGUI gfx = putSP (Low gfx)
putsGUI gfx = putsSP (map Low gfx)

spaceF space initK playK = windowF startcmds (changeBg "black" (K playKSP))
  where
    playKSP = unMk (initK >>= playK) (\()-> nullG)
    
    startcmds = [layoutRequestCmd (plainLayout space True True),
                 XCmd $ ChangeWindowAttributes [CWEventMask eventmask]]
    eventmask = [KeyPressMask,KeyReleaseMask,
                 ButtonPressMask,ButtonReleaseMask,
		 LeaveWindowMask,EnterWindowMask,ExposureMask]

--------------------------------------------------------------------------------

data GEvent = Redraw | Key Action UpDown
data Action = MoveLeft | MoveRight | Fire
data UpDown = Up | Down

getG return = loop
  where
    loop = getSP (message low high)

    high = return . High

    retLow = return . Low

    low (XEvt ev) = event ev
    low _ = loop

    event ev =
      case ev of
        Expose r 0     -> retLow Redraw
        ButtonEvent {} -> btn (type' ev) (button ev)
        KeyEvent    {} -> key (type' ev) (keySym ev)
        _              -> loop

    btn Pressed (Button 2) = retLow (Key Fire Down)
    btn pressed (Button 1) = updown pressed MoveLeft
    btn pressed (Button 3) = updown pressed MoveRight
    btn _       _          = loop

    key Pressed "space"   = retLow (Key Fire Down)
    key pressed "Shift_L" = updown pressed MoveLeft
    key pressed "Shift_R" = updown pressed MoveRight
    key pressed "Left"    = updown pressed MoveLeft
    key pressed "Right"   = updown pressed MoveRight
--  key Pressed _         = putGUI bell loop
    key _ _               = loop

    updown Pressed  a = retLow (Key a Down)
    updown Released a = retLow (Key a Up)
    updown _        _ = loop

--------------------------------------------------------------------------------

data PlacedPict = PP Pict Point
type Pict = FixedColorDrawing

drawPP (PP (FixCD s gcdcmds) p) = [(gc,move p dcmds)|(gc,dcmds)<-gcdcmds]
drawIt obj = concatMap drawPP (drawing obj)
wDraw obj = wDrawMany (drawIt obj)

class Draw obj where drawing :: obj -> [PlacedPict]

instance Draw obj => Draw [obj] where drawing = concatMap drawing

instance (Draw o1,Draw o2) => Draw (o1,o2) where
  drawing (o1,o2) = drawing o1++drawing o2

--------------------------------------------------------------------------------
unMkc op ksp = ksp'
  where K ksp' = unMk op (\c->K (ksp c))

objGC fg = Mk $ unMkc (objGC' fg)

objGC' fg =
  do Just bgpixel <- Mk (tryConvColorK "black")
     Just fgpixel <- Mk (tryConvColorK [fg,"white"])
     let attrs = [GCBackground bgpixel,GCForeground fgpixel]
     Mk (wCreateGC rootGC (GCGraphicsExposures False:attrs))

readPict gc path = pmPict gc <$> readPic' path

readPic' path = Mk $ unMkc (readPic path)

readPicts gc (path1,path2) = (,) <$> readPict gc path1 <*> readPict gc path2

pmPict gc pm@(PixmapImage size _) = FixCD size (copy gc pm 0)

rectangles gc s rs = FixCD s [(gc,map FillRectangle rs)]

text gc s = FixCD (pP (6*length s) 13) [(gc,[DrawString 0 s])] -- !!

clearpm p pict = clear p (size pict)

clear p size = clearRect (Rect p size) False

clearRect r e = XCmd $ ClearArea r e

copy gc pm p = [(gc,[copy' pm p])]
copy' (PixmapImage size pm) p = CopyPlane (Pixmap pm) (Rect origin size) p 0

bell = XCmd (Bell 0)

--------------------------------------------------------------------------------

class HasSize a where size :: a -> Size

instance HasSize PixmapImage where size (PixmapImage s pm) = s
instance HasSize FixedColorDrawing where size (FixCD s _) = s
instance HasSize FixedDrawing where size (FixD s _) = s


--------------------------------------------------------------------------------

baseColor   = argKey "baseColor"   "cyan"
shotColor   = argKey "shotColor"   "lavender"
vader1Color = argKey "vader1Color" "blue"
vader2Color = argKey "vader2Color" "green"
vader3Color = argKey "vader3Color" "red"
vshotColor  = argKey "vshotColor"  "orange"
shelterColor = argKey "shelterColor" "yellow"
ufoColor     = argKey "ufoColor" "grey"
