module ReadPic where
import Control.Applicative
import AllFudgets
import Pics

readPics (file1,file2) =
  (,) <$> readPic file1 <*> readPic file2

readPic file = maybe notFound found (lookup (file++".xbm") pics)
  where
    notFound = fail ("Bitmap not found: "++file)
    found bm =
      do bmr <- Mk (bitmapFromData bm)
         case bmr of
           BitmapReturn size _ pm -> return (PixmapImage size pm)
           BitmapBad -> fail ("Can't read bitmap "++file)
