import Data.List(isSuffixOf)
import Data.List.Split(chunksOf)
import System.Directory(listDirectory)
import PNMparser(parsePNM)
import PNM
import IOUtils(readBinaryFile)
import AllFudgets(BitmapData(..),Point(..))

convert = do paths <- map ("pbm/"++) . filter (".pbm" `isSuffixOf`) <$> listDirectory "pbm"
             pbms <- mapM (fmap parsePNM . readBinaryFile) paths
             return $ zip paths (map (\(Right pbm)->toBitmapData pbm) pbms)

toBitmapData (PNM size@(Point w _) (PBM bits)) =
  BitmapData size Nothing (concatMap bits2ints (chunksOf w bits))

bits2ints = map implode . chunksOf 8

implode = foldr (\b r->fromEnum (b::Bit)+2*r) 0
