module
#include <OK>
export wargs;

wargs argv maxplayers =
  let    usage = "Usage: masken [ players ] [ speed ]\n" @
	         "        players: 1-" @ itos maxplayers @ " (number of players)\n" @
	         "        speed:   25-1000 (milliseconds between ticks)\n"
     and default_speed = 200
     and default_players = 2
     and validspeed s=let speed=stoi s in 25<=speed & speed<=1000
     and validplayer p= let players=stoi p in 1<=players & players<=maxplayers
  in case argv
   in []: Yes (default_players,default_speed)
   || [p;s] & (validplayer p & validspeed s): Yes (stoi p,stoi s)
   || [s;p] & (validspeed s & validplayer p): Yes (stoi p,stoi s)
   || [p] & (validplayer p): Yes (stoi p,default_speed)
   || [s] & (validspeed s): Yes (default_players,stoi s)
   || _ : No usage
   end

end
