module
#include "io.t"
#include "output.t"
#include "move.t"
#include "draw.t"
#include "board.t"
#include "ask.t"
#include "q.t"
#include "play.t"
#include "worm.t"
export masken,maxplayers;

local game players =
let
  rec startdir = left.right.startdir
  and playernos = count 1 players
  and scores0 = map (\n.(n,0)) playernos

  and worms = map (\n.newworm n (select n startpos) (select n startdir) 9 0) playernos

  and prnos nos = mix (map itos nos) " "

  and startgame rnd =
    countdown (head players startpos) 3 !
    return (rnd,worms)

  and gameover scores ((food.rnd,worms),crashed) =
    let newscores=map (\(n,s).if mem n crashed
			      then (n,s)
			      else (n,s+1)) scores
    in pr [movebelow] !
       (if crashed~=[]
        then prs ("Worm no " @ prnos crashed @ " crashed!\n") !
	     (if players>1
	      then pr (concmap showscore newscores)
	      else nop
	     ) !
	     pr [movebelow; Str "\n"]
        else prs "Aborted.\n") !
       prs "Game over! Play again? " !
       yesorno !>
       (\again.
         (if again
          then pr (Str "y".Flush.erase food @
		   concmap (erasemask o wormbody) worms @
		   [movebelow; Str "                     \n";
		   Str "                        "])
          else prs "n\nBye bye!\n") !
         return ((newscores,rnd),again)
       )
in repuntil (\(scores,rnd).
		startgame rnd !>
		play !>
		gameover scores) (scores0,randpos)

in 
  masken players playernames = program (pr (board playernames) ! game players)
  --masken players = program ( pr Clr ! game players )
  and maxplayers = length startpos
end

end
