module
#include "io.t"
#include "output.t"
#include "move.t"
#include "draw.t"
#include "ask.t"
#include "board.t"
#include "q.t"
#include "utils.t"
#include "worm.t"
#include "keys.t"
export play;

rec insideanyworm worms pos= exists (insideworm pos) worms

-- show new piece of food when the old one has been eaten by a worm
and newfood (_.rnd,worms) =
  let (food.rnd)=dropto (not o insideanyworm worms) rnd
  in pr (draw food '&') !
     return (food.rnd,worms)

-- increase the score for a worm and show new score on the screen
and score n (rnd,worms) =
  let newworms = anth n (updscore (+10) o updgrow (+10)) worms
  in pr (showscore (n,wormscore (select n newworms))) !
     return (rnd,newworms)

-- check if any worm has bumped into another worm
and wormcrash _ []=[]
 || wormcrash ws2 (worm.ws)=
   let head=wormhead worm
   in if insideanyworm ws2 head | insideanyworm ws head
      then wormno worm.wormcrash (worm.ws2) ws
      else wormcrash (worm.ws2) ws

-- check if a worm has bumped into the food or another worm
and checkbump selfcrash (state as (food._,worms)) =
  let eat=index [food] (map wormhead worms)+1
  in (if eat>0
      then score eat state !> newfood
      else return state) !>
     (\(rnd,worms).return ((rnd,worms),selfcrash @ wormcrash [] worms))
     --(\(rnd,worms).return ((rnd,worms),[] ))

-- move a worm forward and check if it crashed into the wall or itself
and moveworm w =
  let head=wormhead w
  in let newhead=addv head (wormdir w)
     and (drawtail,w2)= if wormgrow w > 0
                        then ([Str ""],updgrow (+(-1)) w)
                        else afst erase (cutwormtail w)
  in let newworm= movewormhead w2 newhead
  --in let newworm= w2 
     and selfcrash=if outside newhead | qmember (wormbody w2) newhead
                   then [wormno w]
                   else []
  in (drawtail @ draw newhead (chr(wormno w % 10 +ord '0')) @ draw head 'o',newworm,selfcrash)
  --in let dir = [] -- moveto (0,0) @ show_int (fst (wormdir w)) @ "," @ show_int (snd (wormdir w)) @ " "
  --in (dir @ drawtail @ draw newhead (chr(wormno w % 10 +ord '0')) @ draw head 'o',newworm,selfcrash)
  --in (".",newworm,selfcrash)

and moveworms [] = ([],[],[])
 || moveworms (worm.worms)=
   let (output,newworm,selfcrash)=moveworm worm
   --let (output,newworm,selfcrash)=(".",worm,[])
   and (outputs,newworms,crashes)=moveworms worms
   in (output @ outputs,newworm.newworms,selfcrash @ crashes)
   --in (output @ outputs,newworm.newworms,[])

and forward (rnd,worms) =
  let (output,newworms,selfcrash)=moveworms (map changedir worms)
  --let (output,newworms,selfcrash)=moveworms worms
  --let (output,newworms,selfcrash)=(".",worms,[])
  in pr output ! checkbump selfcrash (rnd,newworms)
  --in pr output ! return ((rnd,newworms),[])
  --in prs "." ! return ((rnd,newworms),[])


and dirs = [const up;const left;const right;const down;turnleft;turnright]
and dirkey c=mem c stdkeys
and keydir c=assoc c (combine (stdkeys,dirs))

and storedir n dirchange (rnd,worms) =
  (rnd,anth n (storedirchange dirchange) worms)

and pause = pr [movebelow; Str "Paused. Continue? "] !
            yesorno !>
            (\cont.if cont
                   then pr [movebelow; Str "                 "]
                   else pause
            )

and step state =
  pr [Flush] !
  getc (\k.case k
           in Tick: forward state !>
                    (\(state,crash).
                      if crash~=[]
                      then return (state,crash)
                      else step state
                    )
           || Key n c:
             if dirkey c then step (storedir n (keydir c) state)
             else if c='' then return (state,[])
             else if c='p' then pause ! step state
             else step state
           end)

and showallscores (_,worms)=
  pr (concmap (\w.showscore (wormno w,wormscore w)) worms)

and play state= showallscores state ! newfood state !> step
--and play state=step state

end
