module 

#include <Fudgets.t>
#include "lconnect.t"
rec

    type SocketMsg *a = SocketMsg *a + SocketEOS
and type ServerMsg *a = ServerMsg *a + ServerEOS + ServerNew

and aSocketMsg :: (*a -> *b) -> SocketMsg *a -> SocketMsg *b
and aSocketMsg f (SocketMsg a) = SocketMsg (f a)
||  aSocketMsg f SocketEOS = SocketEOS

--and socketServer :: Port -> (Socket -> F *a (SocketMsg *b))
--                    -> F (Int # *a) (Int # ServerMsg *b)
and socketServer ports f = 
  let rec
      router e =
         let todyn = Inl o Inr
         and out = Inr
         in
            case e in
             -- from control
	       Inl (Inl (i,f)) : [todyn (i,DynCreate f); out (i,ServerNew)]
             -- from dynListF
	    || Inl (Inr (i,m)) : 
               case m in
		  SocketMsg m' : [out (i,ServerMsg m')]
	       || SocketEOS    : [out (i,ServerEOS); todyn (i,DynDestroy)]
	       end
             -- from outside
	    || Inr (i,m) : [todyn (i,DynMsg m)]
	    end

  and control = lconnect ports $ (\lsocket.
         let rec
	     accepter i = 
	       getFu $ (\e. 
	       case e in
		  Low (IOResponse (AsyncInput (_,SocketAccepted socket peer))):
		    putF [High (i,f i socket peer)] $
		  accepter (i+1)
	       || _ : accepter i
	       end)
	 in
	     putFu [Low (DoIO (Select [LSocketDe lsocket]))] $
	     (accepter 0))
  in loopLeftF (idRightF (control :+: dynListF) 
                :=--: concmapSP router)
      
end
