module	-- drawgraph -
#include <Fudgets.t>
#include "graph.t"
#include "lmlmk/utils.t"
export drawGraph,topSidePoint,bottomSidePoint;

rec drawGraph (nodenames,rows) textSize =
  let (p,size)= place nodenames rows textSize
  and mknode (node,(txt,rect)) = (node,Node rect (txt,nodenames node)) -- hmm
  in (size, Graph (map mknode p) (edges p (conc rows)))

and place nodenames rows textSize =
  let noderows = map (map fst) rows
  and Point _ h = textSize "A"
  in let placerow (r,row) =
    let y=yspace*r-(yspace+h)/2
    in let placenode x node =
      let txt = nodetext (nodenames node)
      in let Point w h = textSize txt
      in let d=6
      in (x+w+d+xspace,(node,(txt,Rect (Point x y) (Point (w+d) (h+d)))))
    in mapstate placenode xspace row
  in let nodes = map placerow (number 1 noderows)
  in let xmax = Max (xspace.map fst nodes)
  in (concmap (centerRow xmax) nodes,
      Point xmax (yspace*(length rows)))

and centerRow xmax (w,row) = map ((asnd o asnd) (moveRight ((xmax-w)/2))) row
--and moveRight dx (Rect (Point x y) size)= Rect (Point (x+dx) y) size
and moveRight dx rect = moverect rect (P dx 0)

and edges p = concmap (nodeEdges p)

and nodeEdges p (n,ns) =
  let ra = lookuprect n p
  in let top = topSidePoint ra
  in let edge m = let rb = lookuprect m p
		  in ((n,m),Line top (bottomSidePoint rb))
  in map edge ns

and topSidePoint (Rect (Point x y) (Point w _)) = Point (x+w/2) y
and bottomSidePoint (Rect (Point x y) (Point w h)) = Point (x+w/2) (y+h)

and yspace = stoi (argKey "yspace" "50")
and xspace = stoi (argKey "xspace" "15")

and lookuprect x = snd o assoc x

and nodetext [s] = basename s
 || nodetext (s._) = basename s @ "..." -- don't want too long strings

and basename s = last (choplist (splitat '/') s)

end
