module	-- graphF -
#include <Option>
#include <Fudgets.t>
#include "graph.t"
#include "nodeF.t"
#include "drawgraph.t"
export graphF;

rec exposeEdges gc _ = (Low ClearWindow.) o map (exposeEdge gc)
and exposeEdge gc (_,line) = Low (WDrawLine gc line)

and edgeK es ers gc =
      getK (\msg.
	case msg
	in Low (Expose er n):
		if n>0 then edgeK es (er.ers) gc
		else putK (exposeEdges gc (er.ers) es) (edgeK es [] gc)
	|| High nrect: let (cmds,es') = mapstate (moveedge nrect gc) [] es
		       in putK cmds (edgeK es' ers gc)
	|| _ : edgeK es ers gc
	end)

and moveedge (mvn,mvpos) gc cmds ((n as (topn,botn)),(l as Line top bot)) =
    let mv n p f = if n=mvn
		   then f mvpos
		   else p
    in let top' = mv topn top topSidePoint
    and bot' = mv botn bot bottomSidePoint
    in let l' = Line top' bot'
    in let cmds' = if top'~=top | bot'~=bot
		   then Low (WDrawLine gc l).Low (WDrawLine gc l').cmds
		   else cmds
    in (cmds',(n,l'))

and nodeFs = map (High o Inl o asnd (DynCreate o nodeF))

and graphF unsizedgraph = 
  let wattrs =[CWEventMask [ExposureMask];
	       CWBackingStore Always;
	       CWBitGravity NorthWestGravity]
  in let startcmds size = [Low (ChangeWindowAttributes wattrs);
			   Low (LayoutLimits (Layout size true true))]
  in let gw =
       sizeGraph unsizedgraph (\(size,Graph nnodes nedges).
	 let nnames = map (\(n,Node _ (name,_)).(name,n)) nnodes
	 in allocNamedColor DefaultColormap fgColor (\fgc.
	    changeGetBackPixel bgcolor (\bgc.
	    wCreateGC RootGC (GCLineWidth (Width 2).invertColorGCattrs fgc bgc) (\gc.
	    putK (startcmds size @ nodeFs nnodes @ [High (Inr (-1,"Ready"))])
                 (edgeK nedges [] gc)))))
  in let route (Inr x) = Inr x
      || route (Inl (n,Inl y)) = Inl (n,y)
      || route (Inl (n,Inr x)) = Inr (n,x)
  in loopThroughLeftF (groupF [] None gw (route:-=:idRightF dynListF:=-:stripSum))

and sizeGraph graph fudget = loadQueryFont menuFont (\font.fudget (graph (rectsize o string_rect font)))

and bgcolor = argKey "bg" "skyblue"

end
