module
#include "lmlmk/utils.t"
export	graphmap,       -- apply a function to all nodes and edges of a graph
        revg,	        -- reverse the arrows in a graph
	collapse,	-- collapse a graph
        collapseCycles;  -- create one node per scc

rec revg g =
  let nodes = map fst g
  and deps = concmap (\(x,xs).map (x,) xs) g
  in map (\x.(x,(map fst o filter ((=x) o snd)) deps)) nodes

and collapse f g=
  let gf = graphmap f g
  in let nodes = mkset (map fst gf)
  in map (\n.(n,(mkset o concmap snd o filter ((=n) o fst)) gf)) nodes

and graphmap = map o apair o pairwith map

and collapseCycles (sccs,g)=
  let nsccs = number 1 sccs
  in let sccidtab = concmap (\(id,ns).map (,id) ns) nsccs
  in let sccid n = assoc n sccidtab
  in let sccparttab = array 1 (length sccs) hd nsccs
  in let sccparts n = sccparttab ? n
  in let idg = (map o map o apair o pairwith (mkset oo map)) sccid g
  in (sccparts,idg)

/*
and number g =
  let nodetable = map swap (number 0 (map fst g))
  in let f n = (assoc n nodetable,n)
  in graphmap f g
*/

end
