import Fudgets
import DrawGraph
import GraphF
import GraphUtils
import Graph(GRAPH)
import NewSCC(scc)
import MUtils(collectByFst,mapFst,mapSnd)
import HO
import Data.List
import Data.Maybe

main = do g <- readIO =<< getContents
--        putStr . unlines . map show . uncurry graphmap $ dominators g
          fudlogue ({-showfileF>==<-}graphWindowsF g)

buildGraph = drawGraph . order . optrevg
    --collapse dir .
    --graphmap executableFileName .
    --map (apSnd tail) . snd . extractDependencies

graphWindowsF g = showgraphF (buildGraph g)

showgraphF unsizedg = shellF "Dependency graph" (scrollF (graphF unsizedg))

revopt = argKey "top" "up" == "up"
optrevg = if revopt then revg else id
{-
order2 g = (nm,[[(n,look dg n)|n<-ns]|ns<-tsort (optrevg dg)])
  where
    (nm,dg) = dominators g
-}
order g = (namemap,[[(n,look scg n)|n<-ns]|(_,ns)<-ls])
  where
    (namemap,scg) = myscc g
    ls = sort . collectByFst . mapFst middle $ moduleLevels scg
    middle (lo,hi) = (lo+hi) `div` 2

myscc g = (look namemap,map merge cs)
  where 
    cs = zip [1..] (scc g)
    namemap = [(n,map fst c)|(n,c)<-cs]
    cmap = [(m,n)|(n,ms)<-namemap,m<-ms]
    merge (n,c) = (n,nub [look cmap i|is<-iss,i<-is]\\[n])
      where iss = map snd c

-- http://en.wikipedia.org/wiki/Dominator_%28graph_theory%29
dominators g = (nm,revg immdoms)
  where
    immdoms = [(n,ds\\concatMap (look strictdoms) ds)|(n,ds)<-strictdoms]
    strictdoms = mapSnd tail doms
    doms = map dom rg
    dom (n,is) = 
        case is of
          []  -> (n,[n])
          is -> (n,nub (n:foldr1 intersect [maybe [] id $ lookup i doms|i<-is]))
    (nm,rg) = myscc (revg g)

moduleLevels g = [((look td m,look bu m),m)|(m,_)<-g]
  where
   (_,bu) = levels g
   (h,td') = levels (revg g)
   td = [(m,h-i)|(m,i)<-td']

levels g = (length ls-1,[(m,i)|(i,ms)<-zip [0..] ls,m<-ms])
  where
    ls = tsort g
    ns = map fst g

tsort g = 
  case partition (null . snd) g of
    ([],[])  -> []
    ([],g) -> error $ "cycles in graph: "++show g
    (ms,ms2) -> ns:tsort [(m,[i|i<-is,i `notElem` ns])|(m,is)<-ms2]
        where ns=map fst ms

look ls m = fromJust (lookup m ls)
