module HtmlUtils where
import Text.PrettyPrint
--import ListUtil(concatMap)

escape :: String -> String
escape = concatMap esc
  where esc c = case c of
                  '<' -> "&lt;"
		  '>' -> "&gt;"
		  '&' -> "&amp;"
		  _   -> [c]

wrap cmd txt = on cmd<>txt<>off cmd
tag cmd = zeroWidthText ("<"++cmd++">")
on = tag
off cmd = tag ('/':cmd)
html f = f++".html"
sq s = '\'':s++"'"
dq s = '"':s++"\""

strong = wrap "STRONG"

imgsrc arg = on ("IMG SRC="++dq arg)

link url arg = on ("A HREF="++dq (escape url))<>arg<>off "A"

wrap_id t id arg = on (t++" ID="++dq (escape id))<>arg<>off t

kw = strong . text
plain = text . escape

vmap f = vcat . map f