{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-missing-import-lists #-}
{-# OPTIONS_GHC -fno-warn-implicit-prelude #-}
module Paths_hbc_library (
    version,
    getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir,
    getDataFileName, getSysconfDir
  ) where

import qualified Control.Exception as Exception
import Data.Version (Version(..))
import System.Environment (getEnv)
import Prelude

#if defined(VERSION_base)

#if MIN_VERSION_base(4,0,0)
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#else
catchIO :: IO a -> (Exception.Exception -> IO a) -> IO a
#endif

#else
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#endif
catchIO = Exception.catch

version :: Version
version = Version [0,17] []
bindir, libdir, dynlibdir, datadir, libexecdir, sysconfdir :: FilePath

bindir     = "/Users/hallgren/Library/Haskell/bin"
libdir     = "/Users/hallgren/Library/Haskell/ghc-7.6.3-x86_64/lib/hbc-library-0.17"
dynlibdir  = "/Users/hallgren/Library/Haskell/ghc-7.6.3-x86_64/lib/x86_64-osx-ghc-7.6.3"
datadir    = "/Users/hallgren/Library/Haskell/share/ghc-7.6.3-x86_64/hbc-library-0.17"
libexecdir = "/Users/hallgren/Library/Haskell/libexec"
sysconfdir = "/Users/hallgren/Library/Haskell/etc"

getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir, getSysconfDir :: IO FilePath
getBinDir = catchIO (getEnv "hbc_library_bindir") (\_ -> return bindir)
getLibDir = catchIO (getEnv "hbc_library_libdir") (\_ -> return libdir)
getDynLibDir = catchIO (getEnv "hbc_library_dynlibdir") (\_ -> return dynlibdir)
getDataDir = catchIO (getEnv "hbc_library_datadir") (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "hbc_library_libexecdir") (\_ -> return libexecdir)
getSysconfDir = catchIO (getEnv "hbc_library_sysconfdir") (\_ -> return sysconfdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
