#include <varargs.h>
#include "heap_NHC.h"
#include "doxcall.h"
#include "mutlib.h"
#include <stdio.h>
#include "dialog.h" /* GetAsyncInput */

C_HEADER(primDoXCall)
{
  C_CHECK(10000);
  {
    NodePtr resp, req = C_GETARG1(1);
    IND_REMOVE(req);
    resp=doxcall(GET_CONSTR(req),getpart(req,0,1));
    if(debug>2) fputs("returned from doxcall\n",stderr);
    C_RETURN(resp);
  }
}

C_HEADER(primDoSCall)
{
  C_CHECK(10000);
  {
    NodePtr arg, resp, req = C_GETARG1(1);
    int cno;
    IND_REMOVE(req);
    cno=GET_CONSTR(req);
    arg = cno==GetAsyncInput ? NULL : getpart(req,0,1);
    resp=doScall(cno,arg);
    if(debug>2) fputs("returned from doScall\n",stderr);
    C_RETURN(resp);
  }
}

PTR getpart(PTR pcon,int pos,int cnt)
{
  PTR p=GET_POINTER_ARG1(pcon,pos+1);
  IND_REMOVE(p);
  return p;
}

#if EVALUATE_FROM_C
PTR evaluate(PTR redex)
{
  PTR whnf;

  PUSHPTR(redex);
#if 0
  /* old */
  C_EVALTOS();
#else
  C_EVALTOS(redex);
#endif
  POPPTR(whnf);
  IND_REMOVE(whnf);
  return whnf;
}

void evalstring(PTR ptr,char *buf,int bufsize)
     /* Evaluates a string. The result is guarranteed to be null-terminated.
      * The string will be silently truncated if it is too long.
      */
{
  PTR hd;

  while(bufsize>1) {
    ptr=evaluate(ptr);
    if(ISNIL(ptr)) break;
    SAVE(ptr,hd=evaluate(HDOF(ptr)));
    *buf++=GET_CHAR_VALUE(hd);
    bufsize--;
    ptr=TLOF(ptr);
  }
  *buf='\0';
}
#else
void evalstring(PTR ptr,char *buf,int bufsize)
{
  char *p;

  for(p=buf; p<buf+bufsize-1 && !ISNIL(ptr);p++,ptr=TLOF(ptr))
    *p=GET_CHAR_VALUE(HDOF(ptr));
  *p='\0';
}
#endif

void getPackedStringL(PTR p,char **buf,unsigned *len)
{
  Coninfo cinfo =  GET_CONINFO(p);
  *buf=(char *)&p[1+EXTRA];
  *len= CONINFO_LARGESIZES(cinfo) * sizeof(Node) - CONINFO_LARGEEXTRA(cinfo);
}

PTR mkconstr(cno,argcnt,va_alist)
int cno,argcnt;
va_dcl
{
  int i;
  va_list ap;
  PTR arg;
  NodePtr n = C_ALLOC(1+EXTRA+argcnt);

  if(debug>1) fprintf(stderr,"mkconstr(%d,%d,...)\n",cno,argcnt);

  n[0] = CONSTR(cno,argcnt,0);
  INIT_PROFINFO(n,&dummyProfInfo);
  va_start(ap);
  for(i=1;i<=argcnt;i++) {
    arg = va_arg(ap,PTR);
    n[EXTRA+i] = (Node)arg;
  }
  va_end(ap);
  return n;

}

PTR mkconstr0(int cno)
{
  NodePtr n = C_ALLOC(1+EXTRA+0);
  n[0] = CONSTR(cno,0,0);
  INIT_PROFINFO(n,&dummyProfInfo);

  return n;
}

PTR mkconstr1(int cno,PTR arg)
{
  NodePtr n = C_ALLOC(1+EXTRA+1);
  n[0] = CONSTR(cno,1,0);
  INIT_PROFINFO(n,&dummyProfInfo);
  n[EXTRA+1] = (Node)arg;

  return n;
}

void mkresponse(PTR resp)
{
  fputs("BUG: mkresponse() not supposed to be used in this system\n",stderr);
  exit(1);
}

void mksuccess(void) {
  fputs("BUG: mksuccess() not supposed to be used in this system\n",stderr);
  exit(1);
}

/*
void fileerror(int ioerror,char *filename,char *oper)
{
  fputs("fileerror() not implemented yet",stderr);
  exit(1);
}
*/

int outstring(FILE *f,PTR ptr)
{
#if EVALUATE_FROM_C
  PTR hd;

  for(;;) {
    ptr=evaluate(ptr);
    if(ISNIL(ptr)) break;
    SAVE(ptr,hd=evaluate(HDOF(ptr)));
    putc(GET_CHAR_VALUE(hd),f);
    ptr=TLOF(ptr);
  }
  return 0;
#else
  char buf[10000];
  evalstring(ptr,buf,sizeof(buf));
  fputs(buf,f);
  return 0;
#endif
}

PTR mkestring(unsigned char *as)
{
  unsigned len;
  unsigned char *s;
  PTR p;
  
  REPLAY_ONE_AND_SKIP(len)
    len = strlen(as);
  RECORD_ONE(len);
  
  s = as + len;
  
  C_CHECK(len*sizeCons);
  for(p = mknil(); len--;) {
    char c;
    REPLAY_ONE_AND_SKIP(c)
      c = *--s;
    RECORD_ONE(c);
    p = mkcons(mkchar(c), p);
  }
  return p;
}

PTR mkchar(unsigned char c)
{
  return GET_CHAR(c);
}

int debug=0;
